import java.awt.Image;
import java.awt.image.BufferedImage;

import java.awt.image.ColorModel;

public class BufferedImageFilter2AsImageFilter implements ImageFilter {
	private BufferedImageFilter2 bufImgFilter;
	private BufferedImage inImgBuffer;
	private BufferedImage outImgBuffer;
	
	public BufferedImageFilter2AsImageFilter(BufferedImageFilter2 bufImgFilter) {
		this.bufImgFilter = bufImgFilter;
		this.inImgBuffer = null;
		this.outImgBuffer = null;
	}
	
	public Image createFilteredImage(Image img) {
		// Copy the data from the original image into the input image buffer
		this.inImgBuffer = BufferedImages.copyImageToARGBBufferedImage(img, this.inImgBuffer);
		
		// Ensure output image buffer is size-compatible with the input image
		this.outImgBuffer = BufferedImages.createSizeCompatibleARGBBufferedImage(img, this.outImgBuffer);
		
		// Filter the image
		bufImgFilter.filter(inImgBuffer, outImgBuffer);
		
		// Return the filtered image
		return outImgBuffer;
	}
	
	public String toString() {
		return bufImgFilter.toString();
	}
}