import java.awt.image.BufferedImage;

public class PixelBufferFilterAsBufferedImageFilter implements BufferedImageFilter {
	private PixelBufferFilter pixelBufferFilter;
	private int[] pixelBuffer;
	
	public PixelBufferFilterAsBufferedImageFilter(PixelBufferFilter pixelBufferFilter) {
		this.pixelBufferFilter = pixelBufferFilter;
		this.pixelBuffer = null;
	}
	
	public void filter(BufferedImage img) {
		int width = img.getWidth();
		int height = img.getHeight();
		
		// Copy the image's pixels into the input pixel buffer
		this.pixelBuffer = BufferedImages.copyBufferedImageToARGBPixelBuffer(img, this.pixelBuffer);
		
		// Filter the contents of the pixel buffer
		pixelBufferFilter.filter(width, height, pixelBuffer);
		
		// Store the pixel buffer back into the original image
		BufferedImages.setAllRGB(img, pixelBuffer);
	}
	
	public String toString() {
		return pixelBufferFilter.toString();
	}
}