import java.awt.image.BufferedImage;

public class PixelBufferToBufferedImageFilterAsBufferedImageFilter2 implements BufferedImageFilter2 {
	private PixelBufferToBufferedImageFilter bufImgFilter;
	private int[] inPixelBuffer;
	
	public PixelBufferToBufferedImageFilterAsBufferedImageFilter2(PixelBufferToBufferedImageFilter bufImgFilter) {
		this.bufImgFilter = bufImgFilter;
		this.inPixelBuffer = null;
	}
	
	public void filter(BufferedImage inImg, BufferedImage outImg) {
		int width = inImg.getWidth();
		int height = inImg.getHeight();
		
		// Copy the image's pixels into the pixel buffer
		this.inPixelBuffer = BufferedImages.copyBufferedImageToARGBPixelBuffer(inImg, this.inPixelBuffer);
		
		// Filter the contents of the pixel buffer, storing the result in the output image
		bufImgFilter.filter(width, height, inPixelBuffer, inImg, outImg);
	}
	
	public String toString() {
		return bufImgFilter.toString();
	}
}