public class NormalizeGrayscaleFilter implements PixelBufferFilter {
	// ### FILTER ###
	
	public void filter(int width, int height, int[] pixels) {
		int numPixels = pixels.length;
		
		int minGray = 255;
		int maxGray = 0;
		for (int i=0; i<numPixels; i++) {
			int curGray = Pixels.ARGBToGray(pixels[i]);
			
			if (curGray < minGray) {
				minGray = curGray;
			}
			if (curGray > maxGray) {
				maxGray = curGray;
			}
		}
		
		int range = maxGray-minGray+1;
		for (int i=0; i<numPixels; i++) {
			int curGray = Pixels.ARGBToGray(pixels[i]);
			int normalizedGray = (curGray-minGray)*255/range;
			pixels[i] = Pixels.grayToARGB(normalizedGray);
		}
	}
	
	public String toString() {
		return "Normalize (Grayscale)";
	}
}